   Member

   Include('jhMailSLotCL.inc'),Once


grp_SECURITY_ATTRIBUTES_Type  GROUP,TYPE
nLength                          LONG
lpSecurityDescriptor             LONG
bInheritHandle                   LONG
                              END

grp_OVERLAPPED_Type           GROUP,TYPE
Internal                         LONG
InternalHigh                     LONG
Offset                           LONG
OffsetHigh                       LONG
hEvent                           LONG
                              .


   Map
      MODULE('Windows.DLL')
         CreateMailslot(LONG lpszSlotName,LONG dwMessageSize,LONG dwTimeOut,LONG lpSECURITY_ATTRIBUTES),LONG,PASCAL,RAW,NAME('CreateMailslotA')
         GetMailslotInfo(LONG hMailSlot,*LONG MaxMessageSize,*LONG NextSize,*LONG MessageCount,*LONG ReadTimeout),LONG,PASCAL,NAME('GetMailslotInfo')

         GetLastError(),ULONG,PASCAL

         CloseHandle(LONG inHandle),LONG,PROC,PASCAL

         CreateFile(LONG lpszFileName,LONG dwDesiredAccess,LONG dwShareMode,LONG,LONG dwCreationDisposition,LONG dwFlagsAndAttributes,LONG hTemplateFile),long,PASCAL,RAW,NAME('CreateFileA')
         ReadFile(LONG hFile,LONG lpBuffer,LONG dwBytesToRead,LONG lpBytesRead,LONG lpOVERLAPPED),LONG,PASCAL,RAW,NAME('ReadFile')
         WriteFile(long hFile,LONG lpBuffer,LONG nNumberOfBytesToWrite,LONG lpNumberOfBytesWritten,long lpOverlapped),LONG,PASCAL,RAW,NAME('WriteFile')

         OutputDebugString(*cstring),raw,pascal,name('OutputDebugStringA')
      END
   .



!=======================================================================================================================
!--
jhMailSlotCL_Type.Construct  Procedure
   Code
      !-- Create queues
      SELF.MessageQ &= NEW(MailSlot_MessageQ_Type)
   
      !-- Initialise Class Variables ..
      SELF.hMailslot = -1                                      ! Set handle to -1 initially

      

!=======================================================================================================================
!--
jhMailSlotCL_Type.Destruct    Procedure
   Code
      !-- Release Queues
      Free(SELF.MessageQ)
      DISPOSE(SELF.MessageQ)

      !--  Release MailSlot Handle ?
      if SELF.hMailSlot ~= -1
         CloseHandle(SELF.hMailslot)
      .
      

!=======================================================================================================================
!--
jhMailSlotCL_Type.DebugMSG Procedure(STRING inMSG,STRING inProcName)
   Code
      IF SELF.byDebug
         MESSAGE(inMSG,inProcName)
      .
      
                  
!=======================================================================================================================
!--
jhMailSlotCL_Type.Init     Procedure(String inSlotName)

procName                      EQUATE('jhMailSlot.Init')

   Code
      !-- Set the mailslot short name ..
      SELF.szMailSlotShortName = 'jh' & CLIP(inSlotName)

      SELF.DebugMSG('MailSlot short name = ' & SELF.szMailSlotShortName,procName)
      
                 
      
!=======================================================================================================================
!-- Create a MailSlot handle for the specified slot name
!--         
jhMailSlotCL_Type.initReader Procedure(*WINDOW inWINDOW,<String inSlotName>)
      
procName                         EQUATE('jhMailSlot.initReader')

szMailSlotFullName            CString(128)
grp_Security_Attributes       LIKE(grp_Security_Attributes_Type)

   Code         
      !-- Check the Window has a TIMER
      if inWindow{PROP:Timer} = 0
         inWINDOW{PROP:Timer} = 100
      .
      
      if ~omitted(inSlotName)
         SELF.Init(inSlotName)
      .

      !-- Set the slot name
      szMailSlotFullName = '\\.\mailslot\' & SELF.szMailSlotShortName
            
      !-- Close any existing hMailSlot handle
      SELF.killReader
      
      !-- Create the mailslot..
      SELF.hMailslot = CreateMailslot(ADDRESS(szMailSlotFullName),jhMailSlot:MaxMSGSize,-1,0)   ! 0,ADDRESS(grp_SECURITY_ATTRIBUTES))
      
      SELF.DebugMSG('MailSlot||SlotName = ' & szMailslotFullName & '||hMailSlot = ' & SELF.hMailSlot,procName)


      
!=======================================================================================================================
!-- Kill/Close any reader handle
!--      
jhMailSlotCL_Type.killReader     PROCEDURE
   Code
      !-- Close any existing hMailSlot
      if SELF.hMailSlot ~= -1
         CloseHandle(SELF.hMailSlot)
         SELF.hMailSlot = -1
      .
         
      
!=======================================================================================================================
!-- Send a message to the MailSlot, returns true/false
!--      
jhMailSlotCL_Type.Send  PROCEDURE(STRING inMessage)                                    

procName                   EQUATE('jhMailSlot.Send')

szMailSlotFullName         CString(128)
szBuffer                   CSTRING(425)
dwResult                   LONG
dwBytesWritten             LONG

grp_Security_Attributes    LIKE(grp_Security_Attributes_Type)

GENERIC_READ               equate(080000000h)
GENERIC_WRITE              equate(040000000h)
GENERIC_EXECUTE            equate(020000000h)
GENERIC_ALL                equate(010000000h)
OPEN_EXISTING              equate(3)
FILE_ATTRIBUTE_NORMAL      equate(080h)

FILE_SHARE_READ            equate(1)
INVALID_HANDLE             equate(-1)

   Code
      !-- Set the slot name & message
      szMailSlotFullName = '\\*\mailslot\' & SELF.szMailSlotShortName
      szBuffer = CLIP(inMessage)
      
      !-- Create File/MailSlot ..
      SELF.hMailSlot = CreateFile(ADDRESS(szMailSlotFullName),GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0)

      !-- Check for invalid Handle before we write the message
      IF SELF.hMailSlot ~= INVALID_HANDLE
         dwResult = WriteFile(SELF.hMailSlot,ADDRESS(szBuffer),LEN(szBuffer),ADDRESS(dwBytesWritten),0)
         
         !-- Close the MailSlot
         CloseHandle(SELF.hMailSlot)
         
         SELF.debugMSG('MailSlot send dwResult = ' & dwResult & |
            '|dwBytesWritten = ' & dwBytesWritten & |
            '|Message = ' & inMessage,procName)
      .
      
      RETURN(dwBytesWritten)
      
      

      
!=======================================================================================================================
!--      
jhMailSlotCL_Type.ReadMessage Procedure(*CSTRING ioMessage)
   Code
      GET(SELF.MessageQ,1)
      IF ~ERROR()
         ioMessage = CLIP(SELF.MessageQ.szText)
         DELETE(SELF.MessageQ)
         RETURN(TRUE)
      .
      
      RETURN(FALSE)
      

!=======================================================================================================================
!--      
jhMailSlotCL_Type.ReadMessage    Procedure

szMessage                           CSTRING(jhMailSlot:MaxMSGSize)

   Code
      GET(SELF.MessageQ,1)
      IF ~ERROR()
         szMessage = SELF.MessageQ.szText
         DELETE(SELF.MessageQ)
         RETURN(szMessage)
      .
      
      RETURN('')
      
      

!=======================================================================================================================
!--      
jhMailSlotCL_Type.TakeEvent   Procedure
            
dwMaxMessageSize                 LONG

dwMessageSize                    LONG
dwNextMessageSize                LONG
dwMessages                       LONG
dwTimeout                        Long
dwResult                         LONG

szBuffer                         CString(512)
dwBytesRead                      LONG


   Code
      Case Event()
      of Event:Timer
         !-- Check a mailslot handle exists ..
         if SELF.hMailSlot ~= -1
            
            dwMaxMessageSize = jhMailSlot:MaxMSGSize
            
            !-- Server has to actively look for Messages
            if GetMailSlotInfo(SELF.hMailSlot,dwMaxMessageSize,dwNextMessageSize,dwMessages,dwTimeout) ~= 0
               
               !-- How many messages ?
               if dwMessages
                  szBuffer = ALL('<0>')
                  dwResult = ReadFile(SELF.hMailSlot,ADDRESS(szBuffer),Size(szBuffer),ADDRESS(dwBytesRead),0)
                  if dwResult
                     CLEAR(SELF.MessageQ)
                     SELF.MessageQ.szText = szBuffer
                     Add(SELF.MessageQ)
                     IF ~ERROR()
                        POST(jhMailSlot:Event:Message)
                     .
                  .
               .
            .
         .
      .
      
      